

var importlines = new Array();
var counternames = new Array();
var countervalues = new Array();
var singleline = new Array();
var formfields = new Array();
var importformfields = new Array();
var dummyArray = new Array();
var buttonsArray = new Array();
var countersArray = new Array();
var valuesArray = new Array();
var bgArray = new Array();
var expdata = new Array();
var exportformfields = new Array();

function mymax(arg1,arg2)
	{
		if (arg1 > arg2)
		{return arg1;}
		else
		{return arg2;}
	}

function mymin(arg1,arg)
	{
		if (arg1 < arg2)
		{return arg1;}
		else
		{return arg2;}
	}


function importform()
	{
	importformfields[0] = new FormField();
	importformfields[0].name = 'FileToImport';
	importformfields[0].type = 'selector';
	importformfields[0].extension = '.txt';
	importformfields[0].extension = '.csv';
	importformfields[0].title = 'File To Import';
	importformfields[0].defaultValue = '';
	importformfields[0].description = 'Select a CSV or TXT file to Import';

	importformfields[1] = new FormField();
	importformfields[1].name = 'Overwrite';
	importformfields[1].type = 'checkbox';
	importformfields[1].title = 'Fresh Start';
	importformfields[1].defaultValue = 0;
	importformfields[1].description = 'Remove Current Counters Before Import?';
	
	formResults = form(importformfields,'Import a File','Import','Cancel');

		
	if (formResults != null) 
		{

		if (formResults[1] == 1)
			{
			removecounters();
			}
	
		importfile(formResults[0]);
		drawcounters();
		}
	}

function exportform()
	{
	exportformfields[0] = new FormField();
	exportformfields[0].name = 'ExportFolder';
	exportformfields[0].type = 'selector';
	exportformfields[0].style = 'save';
	exportformfields[0].kind = 'folders';
	exportformfields[0].defaultValue = '';
	exportformfields[0].title = 'Folder to Export into';
	exportformfields[0].description = 'Select a destination folder';
	
	exportformfields[1] = new FormField();
	exportformfields[1].name = 'ExportFileName';
	exportformfields[1].type = 'text';
	exportformfields[1].defaultValue = 'MoreClicksExport';
	exportformfields[1].title = 'Filename';
	exportformfields[1].description = 'Supply a filename\n(.csv will be appended automatically)';
		
	formResults = form(exportformfields,'Export a File','Export','Cancel');

	if (formResults != null) 
		{
		filename = formResults[0] + "/" + formResults[1] + ".csv"
		
		if (filesystem.itemExists(filename))
			{
			alerttext = "That file already exists. Do you want to replace it?";
			response = alert(alerttext, "Replace", "Cancel");
			if (response == 1)
				{
				exportfile(filename);
				}
			}
			else
			{
			exportfile(formResults[0] + "/" + formResults[1] + ".csv");
			}		
		}
	}


function removecounters()
	{
		counternames.splice(0,counternames.length);
		countervalues.splice(0,countervalues.length);
		
	for (count = 0; count<buttonsArray.length;count++)
		{
		bgArray[count].removeFromSuperview();
		buttonsArray[count].removeFromSuperview();
		countersArray[count].removeFromSuperview();
		valuesArray[count].removeFromSuperview();
		}
	}

function importfile(importfilename)
	{
	importlines = filesystem.readFile(importfilename, true);

	for (count = 0; count<importlines.length; count++)
		{
		singleline = importlines[count].split(",");
		counternames.push(singleline[0]);
		countervalues.push(parseInt(singleline[1]));
		}
	}

function exportfile(exportfilename)
	{
	for (count = 0; count<counternames.length;count++)
		{
		expdata[count] = counternames[count] + "," + parseInt(countervalues[count]);
		}
		
	realexpdata = expdata.join("\n") +"\n";
	filesystem.writeFile(exportfilename, realexpdata);
	alert("File Exported Successfully");
	}

function addone(counter)
	{
	countervalues[counter] = parseInt(parseInt(countervalues[counter]) + 1);
	valuesArray[counter].data = parseInt(countervalues[counter]);
	countersArray[counter].width = mymax(0,parseInt(preferences.widgetwidth.value) - 50 - valuesArray[counter].width);
	if(countersArray[counter].width == 0)
		{
		countersArray[counter].visible = false;
		}
		else
		{
		countersArray[counter].visible = true;
		}
	preferences.widgetminwidth.value = mymax(parseInt(preferences.widgetminwidth.value), 46 + valuesArray[counter].width)
	updatewidth()
	}


function retrievecounters()
	{
	counternames = preferences.countnamespref.value.split(",");
	countervalues = preferences.countvaluespref.value.split(",");
	
	for (count = 0; count < countervalues.length; count++)
		{
		countervalues[count] = parseInt(countervalues[count]);
		}
	}


function savecounters()
	{
	preferences.countnamespref.value = counternames.join(",");
	preferences.countvaluespref.value = countervalues.join(",");
	
	savePreferences();
	}

function addcounterabove(counter)
	{
	formfields[0] = new FormField();
	formfields[0].name = 'FormCounterName';
	formfields[0].type = 'text';
	formfields[0].title = 'Counter Text';
	formfields[0].defaultValue = 'New Counter';
	formfields[0].description = 'Description of the thing(s) you are counting';
	
	formfields[1] = new FormField();
	formfields[1].name = 'FormCounterValue';
	formfields[1].type = 'text';
	formfields[1].title = 'Current Count';
	formfields[1].defaultValue = '0';
	formfields[1].description = 'What you have counted to so far';
	
	formResults = form(formfields,'Add a Counter','Save','Cancel');
	
	if (formResults != null) 
		{
		counternames.splice(counter,0,formResults[0]);
		countervalues.splice(counter,0,parseInt(formResults[1]));
		}
	
	drawcounters();
	}

function addcounterbelow(counter)
	{
	if (counter == counternames.length - 1)
		{
		addcounter();
		}
		else
		{
		addcounterabove(parseInt(counter)+1);
		}
	}

function addcounter()
	{
	formfields[0] = new FormField();
	formfields[0].name = 'FormCounterName';
	formfields[0].type = 'text';
	formfields[0].title = 'Counter Text';
	formfields[0].defaultValue = 'New Counter';
	formfields[0].description = 'Description of the thing(s) you are counting';
	
	formfields[1] = new FormField();
	formfields[1].name = 'FormCounterValue';
	formfields[1].type = 'text';
	formfields[1].title = 'Current Count';
	formfields[1].defaultValue = '0';
	formfields[1].description = 'What you have counted to so far';
	
	formResults = form(formfields,'Add a Counter','Save','Cancel');
	
	if (formResults != null) 
		{
		counternames.push(formResults[0]);
		countervalues.push(parseInt(formResults[1]));
		}
		
	drawcounters()
	
	}

function configcounter(counter)
	{
	
	formfields[0] = new FormField();
	formfields[0].name = 'FormCounterName';
	formfields[0].type = 'text';
	formfields[0].title = 'Counter Text';
	formfields[0].defaultValue = counternames[counter];
	formfields[0].description = 'Description of the thing(s) you are counting';
	
	formfields[1] = new FormField();
	formfields[1].name = 'FormCounterValue';
	formfields[1].type = 'text';
	formfields[1].title = 'Current Count';
	formfields[1].defaultValue = countervalues[counter];
	formfields[1].description = 'What you have counted to so far';
		
	formResults = form(formfields,'Configure a Counter','Save','Cancel');
		
	if (formResults != null) 
		{
		counternames[counter] = formResults[0];
		countervalues[counter] = parseInt(formResults[1]);
		}
		
	
	drawcounters()
		
	}

function deletecounter(counter)
	{
	alerttext = "Are you sure you want to delete '" + counternames[counter] + "'?";
	
	response = alert(alerttext, "Delete", "Cancel");
	
	if (response = 1)
		{
		counternames.splice(counter,1);
		countervalues.splice(counter,1);
	
		drawcounters();
		}
	}	

function ZeroOne(counter)
	{
	alerttext = "Are you sure you want to set '" + counternames[counter] + "' to zero?";

	response = alert(alerttext, "Set to Zero", "Cancel");
	
	if (response = 1)
		{
		countervalues[counter] = parseInt(0);
		drawcounters();
		}
	}

function ZeroAll()
	{	
	alerttext = "Are you sure you want to set all counters to zero?";
	
	response = alert(alerttext, "Set All to Zero", "Cancel");

	if (response = 1)
		{
		for (count = 0; count<counternames.length;count++)
			{
			countervalues[count] = parseInt(0);
			}
		drawcounters();
		}
	}

function deleteall()
	{
	alerttext = "Are you sure you want to delete all counters?";
	
	response = alert(alerttext, "Delete", "Cancel");

	if (response = 1)
		{
		counternames.splice(0,counternames.length);
		countervalues.splice(0,countervalues.length);
	
		drawcounters();
		}
	}	


function drawcounters()
	{
	
	preferences.widgetminwidth.value = "60";
	
	for (count = 0; count<buttonsArray.length;count++)
		{
		buttonsArray[count].removeFromSuperview();
		countersArray[count].removeFromSuperview();
		valuesArray[count].removeFromSuperview();
		bgArray[count].removeFromSuperview();
		}
	
	
	for (count = 0; count<counternames.length;count++)
		{
		bgArray[count] = new Image();
		bgArray[count].src = "resources/blank.png";
		bgArray[count].vOffset = count*20 + 32.5;
		bgArray[count].hOffset = 6;
		bgArray[count].height = 20;
		bgArray[count].width = parseInt(preferences.widgetwidth.value) - 12;
		bgArray[count].window = MyWidget;

		if (preferences.bgTrans.value == true) 
			{
			bgArray[count].opacity = 0;
			}
			else
			{
			bgArray[count].opacity = 255;
			}
			
		buttonsArray[count] = new Image();
		buttonsArray[count].src = "resources/button.png";
		buttonsArray[count].vOffset = count*20+35;
		buttonsArray[count].hOffset = 10;
		buttonsArray[count].height = 15;
		buttonsArray[count].width = 20;
		buttonsArray[count].window = MyWidget;
		buttonsArray[count].onMouseUp = "handleButtonClick(" + count + ");";

		valuesArray[count] = new Text();
		valuesArray[count].data = countervalues[count];
		valuesArray[count].vOffset = count*20 + 47;
		valuesArray[count].hOffset = 250;
		valuesArray[count].alignment = "right";
		valuesArray[count].window = MyWidget;
		valuesArray[count].size = 12;
		valuesArray[count].bgOpacity = 0;
		preferences.widgetminwidth.value = mymax(parseInt(preferences.widgetminwidth.value), 46 + valuesArray[count].width)
		
		
		countersArray[count] = new Text();
		countersArray[count].data = counternames[count];
		countersArray[count].vOffset = count*20 + 46;
		countersArray[count].hOffset = 36;
		countersArray[count].window = MyWidget;
		countersArray[count].size = 12;
		countersArray[count].bgOpacity = 0;
		countersArray[count].width = mymax(0,parseInt(preferences.widgetwidth.value) - 50 - valuesArray[count].width);
		if(countersArray[count].width == 0)
			{
			countersArray[count].visible = false;
			}
			else
			{
			countersArray[count].visible = true;
			}
		countersArray[count].truncation = "end";
		
		if (count%2 == 1)
		{
		bgArray[count].colorize = preferences.bgEven.value;
		countersArray[count].color = preferences.textEven.value;
		valuesArray[count].color = preferences.textEven.value;
		
		}
		else
		{
		bgArray[count].colorize = preferences.bgOdd.value;
		countersArray[count].color = preferences.textOdd.value;
		valuesArray[count].color = preferences.textOdd.value;
		}

		var items = new Array();
		items[0] = new MenuItem();
		items[0].title = "Configure '" + counternames[count] + "' ...";
		items[0].onSelect = "configcounter(" + count + ");";
		items[1] = new MenuItem();
		items[1].title = "Add Counter Above '" + counternames[count] + "' ...";
		items[1].onSelect = "addcounterabove(" + count + ");";
		items[2] = new MenuItem();	
		items[2].title = "Add Counter Below '" + counternames[count] + "' ...";
		items[2].onSelect = "addcounterbelow(" + count + ");";
		items[3] = new MenuItem();
		items[3].title = "Delete '" + counternames[count] +"' ...";
		items[3].onSelect = "deletecounter(" + count + ");";
		items[4] = new MenuItem();
		items[4].title = "Set '"+ counternames[count] + "' to Zero ...";
		items[4].onSelect = "ZeroOne(" + count + ");";
		items[5] = new MenuItem();
		items[5].title = "-";

		buttonsArray[count].contextMenuItems = items;
		countersArray[count].contextMenuItems = items;
		valuesArray[count].contextMenuItems = items;
		CounterDesc.data = preferences.WidgetTitle.value;
		CounterDesc.color = preferences.TitleTextColour.value;
		imgtopleft.colorize = preferences.TitleColour.value;
		imgtopmiddle.colorize = preferences.TitleColour.value;
		imgtopright.colorize = preferences.TitleColour.value;
			
		}
		
		updatewidth()
	}	

function handleButtonClick(Counter)
	{
	play(preferences.soundFile.value);
	addone(Counter);
	}


function updatewidth()
	{
	if(parseInt(preferences.widgetminwidth.value) > parseInt(preferences.widgetwidth.value))
		{
		preferences.widgetwidth.value = preferences.widgetminwidth.value;
		}
	
	imgtopmiddle.width = parseInt(preferences.widgetwidth.value) - (imgtopleft.width + imgtopright.width)
	imgtopright.hOffset = imgtopleft.width + imgtopmiddle.width
	CounterDesc.width = parseInt(preferences.widgetwidth.value) - 2*(imgtopleft.width + imgtopright.width)
	CounterDesc.hOffset = parseInt(preferences.widgetwidth.value)/2
	drag.hOffset = parseInt(preferences.widgetwidth.value) - 18
	
	for (count = 0; count<buttonsArray.length;count++)
		{
		valuesArray[count].hOffset = parseInt(preferences.widgetwidth.value)-10;
		bgArray[count].width = parseInt(preferences.widgetwidth.value) - 12;
		countersArray[count].width = mymax(0,parseInt(preferences.widgetwidth.value) - 50 - valuesArray[count].width);
		if(countersArray[count].width == 0)
			{
			countersArray[count].visible = false;
			}
			else
			{
			countersArray[count].visible = true;
			}
		}
	MyWidget.visible = true
	
	}



retrievecounters();	
drawcounters();
updatewidth();
	
	